/* 
   SSL client certificate
   Copyright (C) 2003-2004, Lei Jiang <sledge10@hotmail.com>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA

   $Id: DavSSLClientCertificate.h,v 1.1 2004/11/09 06:56:54 jiang_lei Exp $
*/

#ifndef ONION_HEADER_DAVSSLCLIENTCERTIFICATE_H
#define ONION_HEADER_DAVSSLCLIENTCERTIFICATE_H 1

#include <onion/OnionCfg.h>
#include <onion/DavSSLCertificate.h>

class CDavSSLClientCertificate
{
 public:
  CDavSSLClientCertificate();
  ~CDavSSLClientCertificate();
  CDavSSLClientCertificate& operator =(CDavSSLClientCertificate& master);

  bool IsValid();
  bool Load(const char* pszPath, const char* pszPasswd);
  bool Load(void* pvData, unsigned int unLen, const char* pszPasswd);
  void Clear();
  CDavSSLCertificate& Cert();
  EVP_PKEY* Key();
 private:
  CDavSSLCertificate m_crtMain;
  EVP_PKEY* m_pKey;
};

#endif /*ONION_HEADER_DAVSSLCLIENTCERTIFICATE_H*/
