/* 
   SSL socket I/O methods
   Copyright (C) 2003-2004, Lei Jiang <sledge10@hotmail.com>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA

   $Id: DavSocketIOSSL.h,v 1.1.1.1 2004/07/15 06:58:45 jiang_lei Exp $
*/

#ifndef ONION_HEADER_DAVSOCKETIOSSL_H
#define ONION_HEADER_DAVSOCKETIOSSL_H 1

#include <onion/OnionCfg.h>
#include <onion/IDavSocketIO.h>

/** Class for SSL socket IO operations.
 *
 */

class CDavSocketIOSSL : public IDavSocketIO
{
 public:
  CDavSocketIOSSL();
  ~CDavSocketIOSSL();

  OI_RESULT Readable(CDavSocket* pSocket,
		     int nSecs);
  OI_RESULT Read(CDavSocket* pSocket,
		 char* pszBuf,
		 size_t* punReadLen,
		 int nSecs);
  OI_RESULT Write(CDavSocket* pSocket,
		  const char* pszBuf,
		  size_t* punWrittenLen);
  OI_RESULT ossl_error(CDavSocket *pSocket,
		       int nErrCode);
};

#endif /*ONION_HEADER_DAVSOCKETIOSSL_H*/
